package de.trantor.kroll.servlet.moneytransfer;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class MoneyTransferServlet extends HttpServlet {

	private String title = "berweisungs Servlet";

	public void init(javax.servlet.ServletConfig cfg) throws ServletException {
		super.init(cfg);
	}

	public void handleRequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		boolean isMIDletRequest = false;

		String userAgent = request.getHeader("User-Agent".toLowerCase());
		
		System.out.println(userAgent);
		
		if (userAgent.equals("UeberweisungsMIDlet Profile/MIDP-2.0 Configuration/CLDC-1.0")) {
			isMIDletRequest = true;
		}
		else {
			isMIDletRequest = false;
		}

		if (isMIDletRequest) {
			String midletCommand = request.getParameter("midlet-command");
			if (midletCommand.equals("sendData")) {

				String midletData = request.getParameter("data");

				System.out.println("Received Data = " + midletData);

				String result = "OK";

				try {
					addDataToFile(midletData);
				}
				catch(IOException ex) {
					result = "ERROR";
				}
				
				PrintWriter out = response.getWriter();
				response.setContentType("text/plain");
				out.println(result);
				out.close();
			}
		}
		else {
			String action = request.getParameter("server-action");
			if (action == null) {
				sendLoginScreen(request, response);
			}
			else if (action.equals("Login")) {
				handleLogin(request, response);
			}
			else if (action.equals("Logout")) {
				handleLogout(request, response);
			}

		}
	}

	private void addDataToFile(String data) throws IOException {
		RandomAccessFile raf = new RandomAccessFile("ueberweisungen.txt", "rw");
		raf.seek(raf.length());
		raf.writeUTF(data);
		raf.close();
	}

	private void writeDataFromFile(PrintWriter out) throws IOException {
		RandomAccessFile raf = new RandomAccessFile("ueberweisungen.txt", "rw");
		while (raf.getFilePointer() != raf.length()) {
			String s = raf.readUTF();
			StringTokenizer st = new StringTokenizer(s, ";");
			out.println("<TR>");
			while (st.hasMoreTokens()) {
				out.println("<TD>");
				out.println("<FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + st.nextToken() + "</FONT>");
				out.println("</TD>");
			}
			out.println("</TR>");
		}


		raf.close();
	}
	

	private void handleLogout(HttpServletRequest request, HttpServletResponse response) throws IOException {
		PrintWriter out;
			out = response.getWriter();
			response.setContentType("text/html");
			out.println("<HTML><HEAD><TITLE>");
			out.println(title);
			out.println("</TITLE></HEAD><BODY bgcolor=\"#FFFFFF\">");
			out.println("<H1><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + title + "</FONT></H1>");
			out.println("<H3><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Ausgeloggt.</FONT></H3>");
			out.println("</BODY>");
			out.println("</HTML>");
	}

	private void handleLogin(HttpServletRequest request, HttpServletResponse response) throws IOException {

		String username = request.getParameter("username");
		String password = request.getParameter("password");
		if (username.equals("test") && password.equals("test")) {

			HttpSession session = request.getSession(true);
			session.setAttribute("allowedUser", "true");
			sendList(request, response);
		}
		else {
			PrintWriter out;
			out = response.getWriter();
			response.setContentType("text/html");
			out.println("<HTML><HEAD><TITLE>");
			out.println(title);
			out.println("</TITLE></HEAD><BODY bgcolor=\"#FFFFFF\">");
			out.println("<H1><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + title + "</FONT></H1>");
			out.println("<H4><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#ff0000\">" + "Username oder Passwort falsch! Bitte versuchen Sie es erneut." + "</FONT></H4>");
			out.println("<FORM method=\"POST\">");
			out.println("<TABLE>");
			out.println("<TR>");
			out.println("<TD><FONT face=Geneva,Arial,Helvetica color=#000000 size=-1>Username:</FONT></TD>");
			out.println("<TD><INPUT NAME='username' size='25' maxlength='75'></TD>");
			out.println("</TR>");
			out.println("<TR>");
			out.println("<TD><FONT face=Geneva,Arial,Helvetica color=#000000 size=-1>Passwort:</FONT></TD>");
			out.println("<TD><INPUT NAME='password' TYPE=\"password\" size='12' maxlength='12'></TD>");
			out.println("</TR>");
			out.println("</TABLE>");
			out.println("<INPUT TYPE='submit' Value='Login' name='server-action'>");
			out.println("</FORM>");
			out.println("</BODY>");
			out.println("</HTML>");
		}
	}

	private void sendList(HttpServletRequest request, HttpServletResponse response) throws IOException {
		PrintWriter out;
		out = response.getWriter();
		response.setContentType("text/html");
		out.println("<HTML><HEAD><TITLE>");
		out.println(title);
		out.println("</TITLE></HEAD><BODY bgcolor=\"#FFFFFF\">");
		out.println("<H1><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + title + "</FONT></H1>");
		out.println("<H3><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Liste der gespeicherten berweisungen</FONT></H3>");
		out.println("<TABLE BORDER =\"5\">");
		out.println("<TR>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Name</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">BLZ</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Kontonummer</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Euro</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Cent</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">TAN</FONT></TH>");
		out.println("<TH><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">Verwendungszweck</FONT></TH>");
		out.println("</TR>");
		writeDataFromFile(out);		
		out.println("<TABLE>");
		
		out.println("<FORM method=\"POST\">");
		out.println("<TABLE BORDER=\"5\">");
		out.println("<TR>");
		out.println("<TD bgcolor=\"#C0C0C0\" style=\"width: 50%\"><FONT face=Geneva,Arial,Helvetica color=#000000 size=-1>Aus dem System ausloggen</FONT></TD>");
		out.println("<TD style=\"width: 50%\"><INPUT TYPE='submit' Value='Logout' name='server-action' style=\"width: 100%\"></TD>");
		out.println("</TR>");
		out.println("</TABLE>");
		out.println("</FORM>");
		out.println("</BODY>");
		out.println("</HTML>");
	}

	private void sendLoginScreen(HttpServletRequest request, HttpServletResponse response) throws IOException {
		String action = request.getParameter("server-action");
		if ((action == null && request.getSession().getAttribute("allowedUser") == null)) {
			PrintWriter out;
			out = response.getWriter();
			response.setContentType("text/html");
			out.println("<HTML><HEAD><TITLE>");
			out.println(title);
			out.println("</TITLE></HEAD><BODY bgcolor=\"#FFFFFF\">");
			out.println("<H1><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + title + "</FONT></H1>");
			out.println("<H3><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + "Bitte loggen Sie sich ein:" + "</FONT></H3>");
			out.println("<FORM method=\"POST\">");
			out.println("<TABLE>");
			out.println("<TR>");
			out.println("<TD><FONT face=Geneva,Arial,Helvetica color=#000000 size=-1>Username:</FONT></TD>");
			out.println("<TD><INPUT NAME='username' size='25' maxlength='75'></TD>");
			out.println("</TR>");
			out.println("<TR>");
			out.println("<TD><FONT face=Geneva,Arial,Helvetica color=#000000 size=-1>Passwort:</FONT></TD>");
			out.println("<TD><INPUT NAME='password' TYPE=\"password\" size='12' maxlength='12'></TD>");
			out.println("</TR>");
			out.println("</TABLE>");
			out.println("<INPUT TYPE='submit' Value='Login' name='server-action'>");
			out.println("</FORM>");
			out.println("</BODY>");
			out.println("</HTML>");
		}
		else {
			PrintWriter out;
			out = response.getWriter();
			out.println("<HTML><HEAD><TITLE>");
			out.println(title);
			out.println("</TITLE></HEAD><BODY bgcolor=\"#FFFFFF\">");
			out.println("<H1><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#000000\">" + title + "</FONT></H1>");
			out.println("<H3><FONT FACE=\"Geneva,Arial,Helvetica\" COLOR=\"#ff0000\">" + "Diese Anfrage ist ungltig !" + "</FONT></H3>");
			out.println("<HR>");
			out.println("<pre>");
			out.println("HEADERS:");
			for (Enumeration e = request.getHeaderNames(); e.hasMoreElements();) {
				String header = (String) e.nextElement();
				out.println(header + " = " + request.getHeader(header));
			}

			out.println("PARAMETERS:");
			for (Enumeration e = request.getParameterNames(); e.hasMoreElements();) {
				String parameter = (String) e.nextElement();
				out.println(parameter + " = " + request.getParameter(parameter));
			}

			out.println("</pre>");
			out.println("<HR>");
			out.println("</BODY>");
			out.println("</HTML>");
		}
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		handleRequest(request, response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		handleRequest(request, response);
	}
}
